// test class to demonstrate various OOP concepts
// hussein suleman
// 13 april 2009

public class Test
{
   // create instance variables as private
   // these were originally created as public so they can be accessed with 
   //  dot notation, but private with accessors/mutators is the general technique
   int mark;
   String name;

   // static variable to track number of objects created
   private static int counter;
   
   // constructor with all arguments
   public Test ( String aName, int aMark )
   {
      name = aName;
      mark = aMark;
      addOne(); // increment counter for # of objects
   }
   
   // constructor with one argument
   public Test ( String aName )
   {
      name = aName;
      mark = 0; // set default value
      addOne(); // increment counter for # of objects
   }

   // accessors
   public String getName ()
   {
      return name;
   }
   public static int getCounter ()
   {
      return counter;
   }
   
   // mutators
   public void setMark ( int aMark )
   {
      mark = aMark;
   }

   // increment counter for number of objects created
   private static void addOne ()
   {
      counter++;
   }

   // print the name of the person
   public void printName ()
   {
      System.out.println (name);
   }
   
   // print the mark the person obtained
   public void printMark ()
   {
      System.out.println (mark);
   }
	
   // print out both pieces of information multiple times
   public void printBoth ( int numberOfTimes )
   {
      for ( int counter=0; counter<numberOfTimes; counter++ )
      {
         printName();
         printMark();
      }
   }
	
   // check if the person has passed, assuming a pass mark of 15
   public boolean hasPassed ()
   {
      if (mark>=15)
         return true;
      return false;	
   }
	
   // check of the person has passed, but with a specific pass mark
   public boolean hasPassed2 ( int passMark )
   {
      if (mark>=passMark)
         return true;
      return false;
   }
	
   // get the percentage the person has scored based on a max mark parameter
   public int getPercentage ( int maxMark )
   {
      return (mark * 100) / maxMark;
   }

   // return an exclamation of joy if the person has passed or an empty string
   public String getWheeOrNoWhee ( int passMark )
   {
      if (mark >= passMark )
         return "wheeeeee";
      return "";
   }

   // reset the object's instance variables to default values
   public void resetBoth ()
   {
      name = "default name";
      mark = 50;
   }
   
   // create String representation of object
   public String toString ()
   {
      return name + " - " + mark;
   }
}
